package com.fs.store.domain;

import java.time.LocalDateTime;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fs.common.annotation.Excel;
import com.fs.common.core.domain.BaseEntity;
import lombok.Data;

/**
 * 定时发放优惠券队列对象 fs_coupon_schedule
 *
 * @author fs
 * @date 2025-03-08
 */
@Data
public class FsCouponSchedule extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键ID */
    private Long id;

    /** 用户ID */
    @Excel(name = "用户ID")
    private Long userId;

    /**
     * 用户名称
     */
    @Excel(name = "用户名称")
    private String userName;
    /** 订单ID */
    @Excel(name = "订单ID")
    private Long orderId;

    /** 套餐ID */
    @Excel(name = "套餐ID")
    private Long setmealId;
    /**
     * 套餐名称
     */
    @Excel(name = "套餐名称")
    private Long setmealTitle;

    /** 总月数 */
    @Excel(name = "总月数")
    private Long month;

    /** 当前次数 */
    @Excel(name = "当前次数")
    private Long count;

    /** 0待处理, 1正在处理, 2成功, -1失败, 3用户拒签或者退货 */
    @Excel(name = "0待处理, 1正在处理, 2成功, -1失败, 3用户拒签或者退货")
    private Long status;

    /** 下单时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "下单时间", width = 30, dateFormat = "yyyy-MM-dd")
    private LocalDateTime orderTime;

    /** 执行时间 */
//    @JsonFormat(pattern = "yyyy-MM-dd")
//    @Excel(name = "执行时间", width = 30, dateFormat = "yyyy-MM-dd")
//    private Date executeTime;

    /** 优惠券ID */
    @Excel(name = "优惠券ID")
    private Long couponId;
    /**
     * 优惠券名称
     */
    @Excel(name = "优惠券名称")
    private String couponName;

    /** 优惠券批次ID */
    @Excel(name = "优惠券批次ID")
    private Long couponBatchId;

    /** 预计发送时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "预计发送时间", width = 30, dateFormat = "yyyy-MM-dd")
    private LocalDateTime sendTime;


    /** 实际发送时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "实际发送时间", width = 30, dateFormat = "yyyy-MM-dd")
    private LocalDateTime actualSendTime;

    /** 错误信息 */
    @Excel(name = "错误信息")
    private String errorMessage;

    /** 重试次数 */
    @Excel(name = "重试次数")
    private Long retryCount;

    /** 最大重试次数 */
    @Excel(name = "最大重试次数")
    private Long maxRetries = 3L;

    /** 下次重试时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "下次重试时间", width = 30, dateFormat = "yyyy-MM-dd")
    private LocalDateTime nextRetryTime;

    /** 订单来源 */
    @Excel(name = "订单来源")
    private String sourceType;

}
